SystemOrganization addCategory: #ConfigurationOfQualityAssistant!

ConfigurationOf subclass: #ConfigurationOfQualityAssistant
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ConfigurationOfQualityAssistant'!

!ConfigurationOfQualityAssistant class methodsFor: 'private' stamp: 'YuriyTymchuk 10/21/2014 19:02'!
bootstrapPackage: aString from: aPath 
	| repository version |
	repository := MCHttpRepository
				location: aPath
				user: ''
				password: ''.
	repository
		versionReaderForFileNamed: aString , '.mcz'
		do: [:reader | 
			version := reader version.
			version load.
			version workingCopy repositoryGroup addRepository: repository]! !

!ConfigurationOfQualityAssistant class methodsFor: 'gitfiletree support' stamp: 'YuriyTymchuk 10/21/2014 19:02'!
ensureGitFileTree
	"And all related dependencies."

	Smalltalk
		at: #MCFileTreeGitRepository
		ifAbsent: [ 
			Gofer new
				url: 'http://smalltalkhub.com/mc/Pharo/MetaRepoForPharo30/main';
				configurationOf: 'GitFileTree';
				loadDevelopment ]! !

!ConfigurationOfQualityAssistant class methodsFor: 'private' stamp: 'YuriyTymchuk 10/21/2014 19:02'!
ensureMetacello
	"Bootstrap Gofer (if necessary), bootstrap ConfigurationOfMetacello (using old Gofer API), then load the latest 
	version of Metacello itself."

	Smalltalk at: #MetacelloProject ifAbsent: [
		Smalltalk at: #Gofer ifAbsent: [
			"Current version of Gofer from which to bootstrap - as of 1.0-beta.21"
			self bootstrapPackage: 'Gofer-Core-lr.115' from: 'http://seaside.gemstone.com/ss/metacello' ].
		Smalltalk at: #Gofer ifPresent: [:goferClass | | gofer |
			gofer := goferClass new
				url: 'http://seaside.gemstone.com/ss/metacello';
				yourself.
			[ gofer addPackage: 'ConfigurationOfMetacello' ] on: Warning do: [:ex | ex resume ].
			gofer load ].
		"load 'default' group of Metacello"
		(Smalltalk at: #ConfigurationOfMetacello) perform: #load ]! !

!ConfigurationOfQualityAssistant class methodsFor: 'metacello tool support' stamp: 'YuriyTymchuk 10/21/2014 19:02'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfQualityAssistant class methodsFor: 'metacello tool support' stamp: 'YuriyTymchuk 10/21/2014 19:02'!
lastMetacelloVersionLoad
	"Answer the last version loaded and the list of packages loaded for that version."

	LastVersionLoad == nil ifTrue: [ LastVersionLoad := nil -> 'default' ].
	^LastVersionLoad! !

!ConfigurationOfQualityAssistant class methodsFor: 'loading' stamp: 'YuriyTymchuk 10/21/2014 19:02'!
load
	"self load"

	^self project latestVersion load! !

!ConfigurationOfQualityAssistant class methodsFor: 'unloading Metacello' stamp: 'YuriyTymchuk 10/21/2014 19:02'!
loadDevelopment

	^(self project version: #development) load! !

!ConfigurationOfQualityAssistant class methodsFor: 'metacello tool support' stamp: 'YuriyTymchuk 10/21/2014 19:02'!
metacelloVersion: versionString loads: anArrayOrString
	"Stash the last version loaded and the list of packages loaded for that version. The list
	 of packages will be used by the tools when doing 'Load Package Version'"

	LastVersionLoad := versionString -> anArrayOrString! !

!ConfigurationOfQualityAssistant class methodsFor: 'accessing' stamp: 'YuriyTymchuk 10/21/2014 19:02'!
project

	^self new project! !

!ConfigurationOfQualityAssistant class methodsFor: 'unloading Metacello' stamp: 'YuriyTymchuk 10/21/2014 19:02'!
unloadMetacello

	Smalltalk at: #ConfigurationOfMetacello ifPresent: [:cls | cls unloadMetacello ]! !

!ConfigurationOfQualityAssistant methodsFor: 'symbolic versions' stamp: 'YuriyTymchuk 3/26/2015 14:53'!
development: spec
	<symbolicVersion: #development>
	
	spec for: #'pharo4.x' version: 'v0.1.0-pre'! !

!ConfigurationOfQualityAssistant methodsFor: 'versions' stamp: 'YuriyTymchuk 3/26/2015 14:57'!
pre01: spec
	<version: 'v0.1.0-pre'>
	
	spec
		for: #'pharo4.x'
		do: [ 
			spec
				baseline: 'QualityAssistant'
					with: [ spec repository: 'github://Uko/QualityAssistant:master' ];
				import: 'QualityAssistant' ].! !

!ConfigurationOfQualityAssistant methodsFor: 'symbolic versions' stamp: 'YuriyTymchuk 3/26/2015 14:57'!
stable: spec
	<symbolicVersion: #stable>
	
	spec for: #'pharo4.x' version: 'v0.1.0'! !

!ConfigurationOfQualityAssistant methodsFor: 'versions' stamp: 'YuriyTymchuk 3/26/2015 14:57'!
v01: spec
	<version: 'v0.1.0'>
	
	spec
		for: #'pharo4.x'
		do: [ 
			spec
				baseline: 'QualityAssistant'
					with: [ spec repository: 'github://Uko/QualityAssistant:master' ];
				import: 'QualityAssistant' ].! !
